#include "Define.h"
// UART Ring buffer
UART0_RING_BUFFER_T rb0;
UART1_RING_BUFFER_T rb1;
UART2_RING_BUFFER_T rb2;
UART3_RING_BUFFER_T rb3;
UART4_RING_BUFFER_T rb4;

// Current Tx Interrupt enable state
__IO FlagStatus TxIntStat0;
__IO FlagStatus TxIntStat1;
__IO FlagStatus TxIntStat2;
__IO FlagStatus TxIntStat3;
__IO FlagStatus TxIntStat4;
uint32_t count_trans_data0=0;
uint32_t count_recev_data0=0;
uint8_t uart0_mode=0,uart1_mode=0,uart2_mode=0,uart3_mode=0,uart4_mode=0;

/*----------------- INTERRUPT SERVICE ROUTINES --------------------------*/
/***********************************************************************
 * @brief		UART0 interrupt handler sub-routine
 * @param[in]	None
 * @return 		None
 **********************************************************************/
 void UART0_IRQHander(void)
 {
	uint32_t intsrc, tmp, tmp1;
	/* Determine the interrupt source */
	intsrc = UART_GetIntId(UART_0);
	tmp = intsrc & UART_IIR_INTID_MASK;

	// Receive Line Status
	if (tmp == UART_IIR_INTID_RLS){
		// Check line status
		tmp1 = UART_GetLineStatus(UART_0);
		// Mask out the Receive Ready and Transmit Holding empty status
		tmp1 &= (UART_LSR_OE | UART_LSR_PE | UART_LSR_FE \
				| UART_LSR_BI | UART_LSR_RXFE);
		// If any error exist
		if (tmp1) {
				UARTX_IntErr(UART_0,tmp1);
		}
	}

	// Receive Data Available or Character time-out
	if ((tmp == UART_IIR_INTID_RDA) || (tmp == UART_IIR_INTID_CTI)){
			UARTX_IntReceive(UART_0);
	}

	// Transmit Holding Empty
	if (tmp == UART_IIR_INTID_THRE){
			UARTX_IntTransmit(UART_0);
	}	 
	 
	 
	 
 }
 
 void UART1_IRQHander(void)
 {
	uint32_t intsrc, tmp, tmp1;
	/* Determine the interrupt source */
	intsrc = UART_GetIntId(UART_1);
	tmp = intsrc & UART_IIR_INTID_MASK;

	// Receive Line Status
	if (tmp == UART_IIR_INTID_RLS){
		// Check line status
		tmp1 = UART_GetLineStatus(UART_1);
		// Mask out the Receive Ready and Transmit Holding empty status
		tmp1 &= (UART_LSR_OE | UART_LSR_PE | UART_LSR_FE \
				| UART_LSR_BI | UART_LSR_RXFE);
		// If any error exist
		if (tmp1) {
				UARTX_IntErr(UART_1,tmp1);
		}
	}

	// Receive Data Available or Character time-out
	if ((tmp == UART_IIR_INTID_RDA) || (tmp == UART_IIR_INTID_CTI)){
			UARTX_IntReceive(UART_1);
	}

	// Transmit Holding Empty
	if (tmp == UART_IIR_INTID_THRE){
			UARTX_IntTransmit(UART_1);
	}	 
	 
	 
	 
 }

void UART2_IRQHander(void)
  {
	uint32_t intsrc, tmp, tmp1;
	/* Determine the interrupt source */
	intsrc = UART_GetIntId(UART_2);
	tmp = intsrc & UART_IIR_INTID_MASK;

	// Receive Line Status
	if (tmp == UART_IIR_INTID_RLS){
		// Check line status
		tmp1 = UART_GetLineStatus(UART_2);
		// Mask out the Receive Ready and Transmit Holding empty status
		tmp1 &= (UART_LSR_OE | UART_LSR_PE | UART_LSR_FE \
				| UART_LSR_BI | UART_LSR_RXFE);
		// If any error exist
		if (tmp1) {
				UARTX_IntErr(UART_2,tmp1);
		}
	}

	// Receive Data Available or Character time-out
	if ((tmp == UART_IIR_INTID_RDA) || (tmp == UART_IIR_INTID_CTI)){
			UARTX_IntReceive(UART_2);
	}

	// Transmit Holding Empty
	if (tmp == UART_IIR_INTID_THRE){
			UARTX_IntTransmit(UART_2);
	}	 
	 
	 
	 
 }


void UART3_IRQHander(void)
 {
	uint32_t intsrc, tmp, tmp1;
	/* Determine the interrupt source */
	intsrc = UART_GetIntId(UART_3);
	tmp = intsrc & UART_IIR_INTID_MASK;

	// Receive Line Status
	if (tmp == UART_IIR_INTID_RLS){
		// Check line status
		tmp1 = UART_GetLineStatus(UART_3);
		// Mask out the Receive Ready and Transmit Holding empty status
		tmp1 &= (UART_LSR_OE | UART_LSR_PE | UART_LSR_FE \
				| UART_LSR_BI | UART_LSR_RXFE);
		// If any error exist
		if (tmp1) {
				UARTX_IntErr(UART_3,tmp1);
		}
	}

	// Receive Data Available or Character time-out
	if ((tmp == UART_IIR_INTID_RDA) || (tmp == UART_IIR_INTID_CTI)){
			UARTX_IntReceive(UART_3);
	}

	// Transmit Holding Empty
	if (tmp == UART_IIR_INTID_THRE){
			UARTX_IntTransmit(UART_3);
	}	 
	 
	 
	 
 }

void UART4_IRQHander(void)
  {
	uint32_t intsrc, tmp, tmp1;
	/* Determine the interrupt source */
	intsrc = UART_GetIntId(UART_4);
	tmp = intsrc & UART_IIR_INTID_MASK;

	// Receive Line Status
	if (tmp == UART_IIR_INTID_RLS){
		// Check line status
		tmp1 = UART_GetLineStatus(UART_4);
		// Mask out the Receive Ready and Transmit Holding empty status
		tmp1 &= (UART_LSR_OE | UART_LSR_PE | UART_LSR_FE \
				| UART_LSR_BI | UART_LSR_RXFE);
		// If any error exist
		if (tmp1) {
				UARTX_IntErr(UART_4,tmp1);
		}
	}

	// Receive Data Available or Character time-out
	if ((tmp == UART_IIR_INTID_RDA) || (tmp == UART_IIR_INTID_CTI)){
			UARTX_IntReceive(UART_4);
	}

	// Transmit Holding Empty
	if (tmp == UART_IIR_INTID_THRE){
			UARTX_IntTransmit(UART_4);
	}	 
	 
	 
	 
 }
 
 void UARTX_IntReceive(UART_ID_Type UartID)
{
	uint8_t tmpc;
	uint32_t rLen;

	//while(1){
	switch(UartID)
	{
		case UART_0:
		{
		// Call UART read function in UART driver
		rLen = UART_Receive(UART_0, &tmpc, 1, NONE_BLOCKING);
		// If data received
		if (rLen){
			/* Check if buffer is more space
			 * If no more space, remaining character will be trimmed out
			 */
			if (!BUF0_IS_FULL(rb0.rx_head,rb0.rx_tail)){
				rb0.rx[rb0.rx_head] = tmpc;
				BUF0_INCR(rb0.rx_head);
			}
			 		else 
						{
          rb0.rx_head=RESET;
	        rb0.rx_tail=RESET;
				  rb0.rx[rb0.rx_head] = tmpc;
				  BUF0_INCR(rb0.rx_head);							
 		        }
		}
	}
	break;
			case UART_1:
		{
		// Call UART read function in UART driver
		rLen = UART_Receive(UART_1, &tmpc, 1, NONE_BLOCKING);
		// If data received
		if (rLen){
			/* Check if buffer is more space
			 * If no more space, remaining character will be trimmed out
			 */
			if (!BUF1_IS_FULL(rb1.rx_head,rb1.rx_tail)){
				rb1.rx[rb1.rx_head] = tmpc;
				BUF0_INCR(rb1.rx_head);
			}
			 		else 
						{
          rb1.rx_head=RESET;
	        rb1.rx_tail=RESET;
				  rb1.rx[rb1.rx_head] = tmpc;
				  BUF1_INCR(rb1.rx_head);							
 		        }
		}
	}
	break;
	
			case UART_2:
		{
		// Call UART read function in UART driver
		rLen = UART_Receive(UART_2, &tmpc, 1, NONE_BLOCKING);
		// If data received
		if (rLen){
			/* Check if buffer is more space
			 * If no more space, remaining character will be trimmed out
			 */
			if (!BUF2_IS_FULL(rb2.rx_head,rb2.rx_tail)){
				rb2.rx[rb2.rx_head] = tmpc;
				BUF2_INCR(rb2.rx_head);
			}
			 		else 
						{
          rb2.rx_head=RESET;
	        rb2.rx_tail=RESET;
				  rb2.rx[rb2.rx_head] = tmpc;
				  BUF2_INCR(rb2.rx_head);							
 		        }
		}
	}
	break;
			case UART_3:
		{
		// Call UART read function in UART driver
		rLen = UART_Receive(UART_3, &tmpc, 1, NONE_BLOCKING);
		// If data received
		if (rLen){
			/* Check if buffer is more space
			 * If no more space, remaining character will be trimmed out
			 */
			if (!BUF3_IS_FULL(rb3.rx_head,rb3.rx_tail)){
				rb3.rx[rb3.rx_head] = tmpc;
				BUF3_INCR(rb3.rx_head);
			}
			 		else 
						{
          rb3.rx_head=RESET;
	        rb3.rx_tail=RESET;
				  rb3.rx[rb3.rx_head] = tmpc;
				  BUF3_INCR(rb3.rx_head);							
 		        }
		}
	}
	break;
			case UART_4:
		{
		// Call UART read function in UART driver
		rLen = UART_Receive(UART_4, &tmpc, 1, NONE_BLOCKING);
		// If data received
		if (rLen){
			/* Check if buffer is more space
			 * If no more space, remaining character will be trimmed out
			 */
			if (!BUF4_IS_FULL(rb4.rx_head,rb4.rx_tail)){
				rb4.rx[rb4.rx_head] = tmpc;
				BUF4_INCR(rb4.rx_head);
			}
			 		else 
						{
          rb4.rx_head=RESET;
	        rb4.rx_tail=RESET;
				  rb4.rx[rb4.rx_head] = tmpc;
				  BUF4_INCR(rb4.rx_head);							
 		        }
		}
	}
	break;
	}
}
/********************************************************************//**
 * @brief 		UART transmit function (ring buffer used)
 * @param[in]	None
 * @return 		None
 *********************************************************************/
void UARTX_IntTransmit(UART_ID_Type UartID)
{
	
			switch(UartID)
	{
		case UART_0:
		{
	if(uart0_mode==TIME_SHARING)
	{
    // Disable THRE interrupt
    UART_IntConfig(UART_0, UART_INTCFG_THRE, DISABLE);

	/* Wait for FIFO buffer empty, transfer UART_TX_FIFO_SIZE bytes
	 * of data or break whenever ring buffers are empty */
	/* Wait until THR empty */
    while (UART_CheckBusy(UART_0) == SET);

if (!BUF0_IS_EMPTY(rb0.tx_head,rb0.tx_tail))
    {
        /* Move a piece of data into the transmit FIFO */
    	if (UART_Send(UART_0, (uint8_t *)&rb0.tx[rb0.tx_tail], 1, NONE_BLOCKING)){
        /* Update transmit ring FIFO tail pointer */
        BUF0_INCR(rb0.tx_tail);
     	}
    }
	}
	else
	{
		  // Disable THRE interrupt
    UART_IntConfig(UART_0, UART_INTCFG_THRE, DISABLE);

	/* Wait for FIFO buffer empty, transfer UART_TX_FIFO_SIZE bytes
	 * of data or break whenever ring buffers are empty */
	/* Wait until THR empty */
    while (UART_CheckBusy(UART_0) == SET);

	while (!BUF0_IS_EMPTY(rb0.tx_head,rb0.tx_tail))
    {
        /* Move a piece of data into the transmit FIFO */
    	if (UART_Send(UART_0, (uint8_t *)&rb0.tx[rb0.tx_tail], 1, NONE_BLOCKING)){
        /* Update transmit ring FIFO tail pointer */
        BUF0_INCR(rb0.tx_tail);
    	} else {
    		break;
    	}
    }
	}
    /* If there is no more data to send, disable the transmit
       interrupt - else enable it or keep it enabled */
	if (BUF0_IS_EMPTY(rb0.tx_head, rb0.tx_tail)) {
    	UART_IntConfig(UART_0, UART_INTCFG_THRE, DISABLE);
    	// Reset Tx Interrupt state
    	TxIntStat0 = RESET;
    }
    else{
      	// Set Tx Interrupt state
		TxIntStat0 = SET;
    	UART_IntConfig(UART_0, UART_INTCFG_THRE, ENABLE);
    }
		}
break;
				case UART_1:
		{
	if(uart1_mode==TIME_SHARING)
	{
    // Disable THRE interrupt
    UART_IntConfig(UART_1, UART_INTCFG_THRE, DISABLE);

	/* Wait for FIFO buffer empty, transfer UART_TX_FIFO_SIZE bytes
	 * of data or break whenever ring buffers are empty */
	/* Wait until THR empty */
    while (UART_CheckBusy(UART_1) == SET);

if (!BUF1_IS_EMPTY(rb1.tx_head,rb1.tx_tail))
    {
        /* Move a piece of data into the transmit FIFO */
    	if (UART_Send(UART_1, (uint8_t *)&rb1.tx[rb1.tx_tail], 1, NONE_BLOCKING)){
        /* Update transmit ring FIFO tail pointer */
        BUF1_INCR(rb1.tx_tail);
     	}
    }
	}
	else
	{
		  // Disable THRE interrupt
    UART_IntConfig(UART_1, UART_INTCFG_THRE, DISABLE);

	/* Wait for FIFO buffer empty, transfer UART_TX_FIFO_SIZE bytes
	 * of data or break whenever ring buffers are empty */
	/* Wait until THR empty */
    while (UART_CheckBusy(UART_1) == SET);

	while (!BUF1_IS_EMPTY(rb1.tx_head,rb1.tx_tail))
    {
        /* Move a piece of data into the transmit FIFO */
    	if (UART_Send(UART_1, (uint8_t *)&rb1.tx[rb1.tx_tail], 1, NONE_BLOCKING)){
        /* Update transmit ring FIFO tail pointer */
        BUF1_INCR(rb1.tx_tail);
    	} else {
    		break;
    	}
    }
	}
    /* If there is no more data to send, disable the transmit
       interrupt - else enable it or keep it enabled */
	if (BUF1_IS_EMPTY(rb1.tx_head, rb1.tx_tail)) {
    	UART_IntConfig(UART_1, UART_INTCFG_THRE, DISABLE);
    	// Reset Tx Interrupt state
    	TxIntStat1 = RESET;
    }
    else{
      	// Set Tx Interrupt state
		TxIntStat1 = SET;
    	UART_IntConfig(UART_1, UART_INTCFG_THRE, ENABLE);
    }
		}
break;
				case UART_2:
		{
	if(uart2_mode==TIME_SHARING)
	{
    // Disable THRE interrupt
    UART_IntConfig(UART_2, UART_INTCFG_THRE, DISABLE);

	/* Wait for FIFO buffer empty, transfer UART_TX_FIFO_SIZE bytes
	 * of data or break whenever ring buffers are empty */
	/* Wait until THR empty */
    while (UART_CheckBusy(UART_2) == SET);

if (!BUF2_IS_EMPTY(rb2.tx_head,rb2.tx_tail))
    {
        /* Move a piece of data into the transmit FIFO */
    	if (UART_Send(UART_2, (uint8_t *)&rb2.tx[rb2.tx_tail], 1, NONE_BLOCKING)){
        /* Update transmit ring FIFO tail pointer */
        BUF2_INCR(rb2.tx_tail);
     	}
    }
	}
	else
	{
		  // Disable THRE interrupt
    UART_IntConfig(UART_2, UART_INTCFG_THRE, DISABLE);

	/* Wait for FIFO buffer empty, transfer UART_TX_FIFO_SIZE bytes
	 * of data or break whenever ring buffers are empty */
	/* Wait until THR empty */
    while (UART_CheckBusy(UART_2) == SET);

	while (!BUF2_IS_EMPTY(rb2.tx_head,rb2.tx_tail))
    {
        /* Move a piece of data into the transmit FIFO */
    	if (UART_Send(UART_2, (uint8_t *)&rb2.tx[rb2.tx_tail], 1, NONE_BLOCKING)){
        /* Update transmit ring FIFO tail pointer */
        BUF2_INCR(rb2.tx_tail);
    	} else {
    		break;
    	}
    }
	}
    /* If there is no more data to send, disable the transmit
       interrupt - else enable it or keep it enabled */
	if (BUF2_IS_EMPTY(rb2.tx_head, rb2.tx_tail)) {
    	UART_IntConfig(UART_2, UART_INTCFG_THRE, DISABLE);
    	// Reset Tx Interrupt state
    	TxIntStat2 = RESET;
    }
    else{
      	// Set Tx Interrupt state
		TxIntStat2 = SET;
    	UART_IntConfig(UART_2, UART_INTCFG_THRE, ENABLE);
    }
		}
break;
				case UART_3:
		{
	if(uart3_mode==TIME_SHARING)
	{
    // Disable THRE interrupt
    UART_IntConfig(UART_3, UART_INTCFG_THRE, DISABLE);

	/* Wait for FIFO buffer empty, transfer UART_TX_FIFO_SIZE bytes
	 * of data or break whenever ring buffers are empty */
	/* Wait until THR empty */
    while (UART_CheckBusy(UART_3) == SET);

if (!BUF3_IS_EMPTY(rb3.tx_head,rb3.tx_tail))
    {
        /* Move a piece of data into the transmit FIFO */
    	if (UART_Send(UART_3, (uint8_t *)&rb3.tx[rb3.tx_tail], 1, NONE_BLOCKING)){
        /* Update transmit ring FIFO tail pointer */
        BUF3_INCR(rb3.tx_tail);
     	}
    }
	}
	else
	{
		  // Disable THRE interrupt
    UART_IntConfig(UART_3, UART_INTCFG_THRE, DISABLE);

	/* Wait for FIFO buffer empty, transfer UART_TX_FIFO_SIZE bytes
	 * of data or break whenever ring buffers are empty */
	/* Wait until THR empty */
    while (UART_CheckBusy(UART_3) == SET);

	while (!BUF3_IS_EMPTY(rb3.tx_head,rb3.tx_tail))
    {
        /* Move a piece of data into the transmit FIFO */
    	if (UART_Send(UART_3, (uint8_t *)&rb3.tx[rb3.tx_tail], 1, NONE_BLOCKING)){
        /* Update transmit ring FIFO tail pointer */
        BUF3_INCR(rb3.tx_tail);
    	} else {
    		break;
    	}
    }
	}
    /* If there is no more data to send, disable the transmit
       interrupt - else enable it or keep it enabled */
	if (BUF3_IS_EMPTY(rb3.tx_head, rb3.tx_tail)) {
    	UART_IntConfig(UART_3, UART_INTCFG_THRE, DISABLE);
    	// Reset Tx Interrupt state
    	TxIntStat3 = RESET;
    }
    else{
      	// Set Tx Interrupt state
		TxIntStat3 = SET;
    	UART_IntConfig(UART_3, UART_INTCFG_THRE, ENABLE);
    }
		}
break;
				case UART_4:
		{
	if(uart4_mode==TIME_SHARING)
	{
    // Disable THRE interrupt
    UART_IntConfig(UART_4, UART_INTCFG_THRE, DISABLE);

	/* Wait for FIFO buffer empty, transfer UART_TX_FIFO_SIZE bytes
	 * of data or break whenever ring buffers are empty */
	/* Wait until THR empty */
    while (UART_CheckBusy(UART_4) == SET);

if (!BUF4_IS_EMPTY(rb4.tx_head,rb4.tx_tail))
    {
        /* Move a piece of data into the transmit FIFO */
    	if (UART_Send(UART_4, (uint8_t *)&rb4.tx[rb4.tx_tail], 1, NONE_BLOCKING)){
        /* Update transmit ring FIFO tail pointer */
        BUF4_INCR(rb4.tx_tail);
     	}
    }
	}
	else
	{
		  // Disable THRE interrupt
    UART_IntConfig(UART_4, UART_INTCFG_THRE, DISABLE);

	/* Wait for FIFO buffer empty, transfer UART_TX_FIFO_SIZE bytes
	 * of data or break whenever ring buffers are empty */
	/* Wait until THR empty */
    while (UART_CheckBusy(UART_4) == SET);

	while (!BUF4_IS_EMPTY(rb4.tx_head,rb4.tx_tail))
    {
        /* Move a piece of data into the transmit FIFO */
    	if (UART_Send(UART_4, (uint8_t *)&rb4.tx[rb4.tx_tail], 1, NONE_BLOCKING)){
        /* Update transmit ring FIFO tail pointer */
        BUF4_INCR(rb4.tx_tail);
    	} else {
    		break;
    	}
    }
	}
    /* If there is no more data to send, disable the transmit
       interrupt - else enable it or keep it enabled */
	if (BUF4_IS_EMPTY(rb4.tx_head, rb4.tx_tail)) {
    	UART_IntConfig(UART_4, UART_INTCFG_THRE, DISABLE);
    	// Reset Tx Interrupt state
    	TxIntStat4 = RESET;
    }
    else{
      	// Set Tx Interrupt state
		TxIntStat4 = SET;
    	UART_IntConfig(UART_4, UART_INTCFG_THRE, ENABLE);
    }
		}
break;
	}	

}

/*********************************************************************//**
 * @brief		UART Line Status Error
 * @param[in]	bLSErrType	UART Line Status Error Type
 * @return		None
 **********************************************************************/
void UARTX_IntErr(UART_ID_Type UartID,uint8_t bLSErrType)
{
		switch(UartID)
	{
		case UART_0:
		{
	while (1)
		{
		// For testing purpose
	  }
		}
				case UART_1:
		{
	while (1)
		{
		// For testing purpose
	  }
		}
				case UART_2:
		{
	while (1)
		{
		// For testing purpose
	  }
		}
				case UART_3:
		{
	while (1)
		{
		// For testing purpose
	  }
		}
				case UART_4:
		{
	while (1)
		{
		// For testing purpose
	  }
		}
	}	
	// Loop forever

}

/*-------------------------PRIVATE FUNCTIONS------------------------------*/
/*********************************************************************//**
 * @brief		UART transmit function for interrupt mode (using ring buffers)
 * @param[in]	UARTPort	Selected UART peripheral used to send data,
 * 				should be UART0
 * @param[out]	txbuf Pointer to Transmit buffer
 * @param[in]	buflen Length of Transmit buffer
 * @return 		Number of bytes actually sent to the ring buffer
 **********************************************************************/
uint32_t UARTX_Send(UART_ID_Type UartID,uint8_t *txbuf, uint32_t buflen,uint32_t count,uint8_t mode)
{
uint8_t *data = (uint8_t *) txbuf;
    uint32_t bytes0= 0,bytes1= 0,bytes2= 0,bytes3= 0,bytes4= 0;
		switch(UartID)
	{
		case UART_0:
		{
	if(mode==TIME_SHARING)
		{
uart0_mode=TIME_SHARING;
	/* Temporarily lock out UART transmit interrupts during this
	   read so the UART transmit interrupt won't cause problems
	   with the index values */
   //UART_IntConfig(UART_0, UART_INTCFG_THRE, DISABLE);

	/* Loop until transmit run buffer is full or until n_bytes
	   expires */
	/*while*/if ((buflen > 0) && (!BUF0_IS_FULL(rb0.tx_head, rb0.tx_tail)))
	{
		/* Write data from buffer into ring buffer */
		rb0.tx[rb0.tx_head] = *(data+count);
		//data++;

		/* Increment head pointer */
		BUF0_INCR(rb0.tx_head);

		/* Increment data count and decrement buffer size count */
		bytes0=bytes0+count;
		buflen=buflen-count;
	}
 }
 else
 {
	uart0_mode=RING;	
	/* Temporarily lock out UART transmit interrupts during this
	   read so the UART transmit interrupt won't cause problems
	   with the index values */
    UART_IntConfig(UART_0, UART_INTCFG_THRE, DISABLE);

	/* Loop until transmit run buffer is full or until n_bytes
	   expires */
	while ((buflen > 0) && (!BUF0_IS_FULL(rb0.tx_head, rb0.tx_tail)))
	{
		/* Write data from buffer into ring buffer */
		rb0.tx[rb0.tx_head] = *data;
		data++;

		/* Increment head pointer */
		BUF0_INCR(rb0.tx_head);

		/* Increment data count and decrement buffer size count */
		bytes0++;
		buflen--;
		}
	}
	/*
	 * Check if current Tx interrupt enable is reset,
	 * that means the Tx interrupt must be re-enabled
	 * due to call UART_IntTransmit() function to trigger
	 * this interrupt type
	 */
	if (TxIntStat0 == RESET) {
		UARTX_IntTransmit(UartID);
	}
	/*
	 * Otherwise, re-enables Tx Interrupt
	 */
	else {
		UART_IntConfig(UART_0, UART_INTCFG_THRE, ENABLE);
	}

    return bytes0;	
}
				case UART_1:
		{
	if(mode==TIME_SHARING)
		{
uart1_mode=TIME_SHARING;
	/* Temporarily lock out UART transmit interrupts during this
	   read so the UART transmit interrupt won't cause problems
	   with the index values */
   // UART_IntConfig(UART_0, UART_INTCFG_THRE, DISABLE);

	/* Loop until transmit run buffer is full or until n_bytes
	   expires */
	/*while*/if ((buflen > 0) && (!BUF1_IS_FULL(rb1.tx_head, rb1.tx_tail)))
	{
		/* Write data from buffer into ring buffer */
		rb1.tx[rb1.tx_head] = *(data+count);
		//data++;

		/* Increment head pointer */
		BUF1_INCR(rb1.tx_head);

		/* Increment data count and decrement buffer size count */
		bytes1=bytes1+count;
		buflen=buflen-count;
	}
 }
 else
 {
	uart1_mode=RING;	
	/* Temporarily lock out UART transmit interrupts during this
	   read so the UART transmit interrupt won't cause problems
	   with the index values */
    UART_IntConfig(UART_1, UART_INTCFG_THRE, DISABLE);

	/* Loop until transmit run buffer is full or until n_bytes
	   expires */
	while ((buflen > 0) && (!BUF1_IS_FULL(rb1.tx_head, rb1.tx_tail)))
	{
		/* Write data from buffer into ring buffer */
		rb1.tx[rb1.tx_head] = *data;
		data++;

		/* Increment head pointer */
		BUF1_INCR(rb1.tx_head);

		/* Increment data count and decrement buffer size count */
		bytes1++;
		buflen--;
		}
	}
	/*
	 * Check if current Tx interrupt enable is reset,
	 * that means the Tx interrupt must be re-enabled
	 * due to call UART_IntTransmit() function to trigger
	 * this interrupt type
	 */
	if (TxIntStat1 == RESET) {
		UARTX_IntTransmit(UartID);
	}
	/*
	 * Otherwise, re-enables Tx Interrupt
	 */
	else {
		UART_IntConfig(UART_1, UART_INTCFG_THRE, ENABLE);
	}

    return bytes1;	
}
				case UART_2:
		{
	if(mode==TIME_SHARING)
		{
uart2_mode=TIME_SHARING;
	/* Temporarily lock out UART transmit interrupts during this
	   read so the UART transmit interrupt won't cause problems
	   with the index values */
   // UART_IntConfig(UART_0, UART_INTCFG_THRE, DISABLE);

	/* Loop until transmit run buffer is full or until n_bytes
	   expires */
	/*while*/if ((buflen > 0) && (!BUF2_IS_FULL(rb2.tx_head, rb2.tx_tail)))
	{
		/* Write data from buffer into ring buffer */
		rb2.tx[rb2.tx_head] = *(data+count);
		//data++;

		/* Increment head pointer */
		BUF2_INCR(rb2.tx_head);

		/* Increment data count and decrement buffer size count */
		bytes2=bytes2+count;
		buflen=buflen-count;
	}
 }
 else
 {
	uart2_mode=RING;	
	/* Temporarily lock out UART transmit interrupts during this
	   read so the UART transmit interrupt won't cause problems
	   with the index values */
    UART_IntConfig(UART_2, UART_INTCFG_THRE, DISABLE);

	/* Loop until transmit run buffer is full or until n_bytes
	   expires */
	while ((buflen > 0) && (!BUF2_IS_FULL(rb2.tx_head, rb2.tx_tail)))
	{
		/* Write data from buffer into ring buffer */
		rb2.tx[rb2.tx_head] = *data;
		data++;

		/* Increment head pointer */
		BUF2_INCR(rb2.tx_head);

		/* Increment data count and decrement buffer size count */
		bytes1++;
		buflen--;
		}
	}
	/*
	 * Check if current Tx interrupt enable is reset,
	 * that means the Tx interrupt must be re-enabled
	 * due to call UART_IntTransmit() function to trigger
	 * this interrupt type
	 */
	if (TxIntStat2 == RESET) {
		UARTX_IntTransmit(UartID);
	}
	/*
	 * Otherwise, re-enables Tx Interrupt
	 */
	else {
		UART_IntConfig(UART_2, UART_INTCFG_THRE, ENABLE);
	}

    return bytes2;	
}
				case UART_3:
		{
	if(mode==TIME_SHARING)
		{
uart3_mode=TIME_SHARING;
	/* Temporarily lock out UART transmit interrupts during this
	   read so the UART transmit interrupt won't cause problems
	   with the index values */
   // UART_IntConfig(UART_0, UART_INTCFG_THRE, DISABLE);

	/* Loop until transmit run buffer is full or until n_bytes
	   expires */
	/*while*/if ((buflen > 0) && (!BUF3_IS_FULL(rb3.tx_head, rb3.tx_tail)))
	{
		/* Write data from buffer into ring buffer */
		rb3.tx[rb3.tx_head] = *(data+count);
		//data++;

		/* Increment head pointer */
		BUF1_INCR(rb3.tx_head);

		/* Increment data count and decrement buffer size count */
		bytes3=bytes3+count;
		buflen=buflen-count;
	}
 }
 else
 {
	uart3_mode=RING;	
	/* Temporarily lock out UART transmit interrupts during this
	   read so the UART transmit interrupt won't cause problems
	   with the index values */
    UART_IntConfig(UART_3, UART_INTCFG_THRE, DISABLE);

	/* Loop until transmit run buffer is full or until n_bytes
	   expires */
	while ((buflen > 0) && (!BUF3_IS_FULL(rb3.tx_head, rb3.tx_tail)))
	{
		/* Write data from buffer into ring buffer */
		rb3.tx[rb3.tx_head] = *data;
		data++;

		/* Increment head pointer */
		BUF3_INCR(rb3.tx_head);

		/* Increment data count and decrement buffer size count */
		bytes3++;
		buflen--;
		}
	}
/*
	 * Check if current Tx interrupt enable is reset,
	 * that means the Tx interrupt must be re-enabled
	 * due to call UART_IntTransmit() function to trigger
	 * this interrupt type
	 */
	if (TxIntStat3 == RESET) {
		UARTX_IntTransmit(UartID);
	}
	/*
	 * Otherwise, re-enables Tx Interrupt
	 */
	else {
		UART_IntConfig(UART_3, UART_INTCFG_THRE, ENABLE);
	}

    return bytes3;		
}
				case UART_4:
		{
	if(mode==TIME_SHARING)
		{
uart4_mode=TIME_SHARING;
	/* Temporarily lock out UART transmit interrupts during this
	   read so the UART transmit interrupt won't cause problems
	   with the index values */
   // UART_IntConfig(UART_0, UART_INTCFG_THRE, DISABLE);

	/* Loop until transmit run buffer is full or until n_bytes
	   expires */
	/*while*/if ((buflen > 0) && (!BUF4_IS_FULL(rb4.tx_head, rb4.tx_tail)))
	{
		/* Write data from buffer into ring buffer */
		rb4.tx[rb4.tx_head] = *(data+count);
		//data++;

		/* Increment head pointer */
		BUF4_INCR(rb4.tx_head);

		/* Increment data count and decrement buffer size count */
		bytes4=bytes4+count;
		buflen=buflen-count;
	}
 }
 else
 {
	uart4_mode=RING;	
	/* Temporarily lock out UART transmit interrupts during this
	   read so the UART transmit interrupt won't cause problems
	   with the index values */
    UART_IntConfig(UART_4, UART_INTCFG_THRE, DISABLE);

	/* Loop until transmit run buffer is full or until n_bytes
	   expires */
	while ((buflen > 0) && (!BUF4_IS_FULL(rb4.tx_head, rb4.tx_tail)))
	{
		/* Write data from buffer into ring buffer */
		rb4.tx[rb4.tx_head] = *data;
		data++;

		/* Increment head pointer */
		BUF4_INCR(rb4.tx_head);

		/* Increment data count and decrement buffer size count */
		bytes4++;
		buflen--;
		}
	}
/*
	 * Check if current Tx interrupt enable is reset,
	 * that means the Tx interrupt must be re-enabled
	 * due to call UART_IntTransmit() function to trigger
	 * this interrupt type
	 */
	if (TxIntStat4 == RESET) {
		UARTX_IntTransmit(UartID);
	}
	/*
	 * Otherwise, re-enables Tx Interrupt
	 */
	else {
		UART_IntConfig(UART_4, UART_INTCFG_THRE, ENABLE);
	}

    return bytes4;		
}
	}	
	return 0;

}

/*********************************************************************//**
 * @brief		UART read function for interrupt mode (using ring buffers)
 * @param[in]	UARTPort	Selected UART peripheral used to send data,
 * 				should be UART0
 * @param[out]	rxbuf Pointer to Received buffer
 * @param[in]	buflen Length of Received buffer
 * @return 		Number of bytes actually read from the ring buffer
 **********************************************************************/
void UARTX_Receive(UART_ID_Type UartID, uint8_t *rxbuf, uint32_t buflen,uint8_t mode)
{
    uint8_t *data = (uint8_t *) rxbuf;

	switch(UartID)
	{
		case UART_0:
		{
	/* Temporarily lock out UART receive interrupts during this
	   read so the UART receive interrupt won't cause problems
	   with the index values */
	UART_IntConfig(UartID, UART_INTCFG_RBR, DISABLE);

	/* Loop until receive buffer ring is empty or
		until max_bytes expires */
	if ((buflen > 0) && (!(BUF0_IS_EMPTY(rb0.rx_head, rb0.rx_tail))))
	{
		/* Read data from ring buffer into user buffer */
		*data = rb0.rx[rb0.rx_tail];
//		data++;

		/* Update tail pointer */
		BUF0_INCR(rb0.rx_tail);

	}

	/* Re-enable UART interrupts */
	UART_IntConfig(UartID, UART_INTCFG_RBR, ENABLE);
}
break;
		case UART_1:
		{
	/* Temporarily lock out UART receive interrupts during this
	   read so the UART receive interrupt won't cause problems
	   with the index values */
	UART_IntConfig(UartID, UART_INTCFG_RBR, DISABLE);

	/* Loop until receive buffer ring is empty or
		until max_bytes expires */
	if ((buflen > 0) && (!(BUF1_IS_EMPTY(rb1.rx_head, rb1.rx_tail))))
	{
		/* Read data from ring buffer into user buffer */
		*data = rb1.rx[rb1.rx_tail];
//		data++;

		/* Update tail pointer */
		BUF0_INCR(rb1.rx_tail);

	}

	/* Re-enable UART interrupts */
	UART_IntConfig(UartID, UART_INTCFG_RBR, ENABLE);
}
break;
		case UART_2:
		{
	/* Temporarily lock out UART receive interrupts during this
	   read so the UART receive interrupt won't cause problems
	   with the index values */
	UART_IntConfig(UartID, UART_INTCFG_RBR, DISABLE);

	/* Loop until receive buffer ring is empty or
		until max_bytes expires */
	if ((buflen > 0) && (!(BUF2_IS_EMPTY(rb2.rx_head, rb2.rx_tail))))
	{
		/* Read data from ring buffer into user buffer */
		*data = rb2.rx[rb2.rx_tail];
//		data++;

		/* Update tail pointer */
		BUF0_INCR(rb2.rx_tail);

	}

	/* Re-enable UART interrupts */
	UART_IntConfig(UartID, UART_INTCFG_RBR, ENABLE);
}
break;
		case UART_3:
		{
	/* Temporarily lock out UART receive interrupts during this
	   read so the UART receive interrupt won't cause problems
	   with the index values */
	UART_IntConfig(UartID, UART_INTCFG_RBR, DISABLE);

	/* Loop until receive buffer ring is empty or
		until max_bytes expires */
	if ((buflen > 0) && (!(BUF3_IS_EMPTY(rb3.rx_head, rb3.rx_tail))))
	{
		/* Read data from ring buffer into user buffer */
		*data = rb3.rx[rb3.rx_tail];
//		data++;

		/* Update tail pointer */
		BUF0_INCR(rb3.rx_tail);

	}

	/* Re-enable UART interrupts */
	UART_IntConfig(UartID, UART_INTCFG_RBR, ENABLE);
}
break;
		case UART_4:
		{
	/* Temporarily lock out UART receive interrupts during this
	   read so the UART receive interrupt won't cause problems
	   with the index values */
	UART_IntConfig(UartID, UART_INTCFG_RBR, DISABLE);

	/* Loop until receive buffer ring is empty or
		until max_bytes expires */
	if ((buflen > 0) && (!(BUF4_IS_EMPTY(rb4.rx_head, rb4.rx_tail))))
	{
		/* Read data from ring buffer into user buffer */
		*data = rb4.rx[rb4.rx_tail];
//		data++;

		/* Update tail pointer */
		BUF0_INCR(rb4.rx_tail);

	}

	/* Re-enable UART interrupts */
	UART_IntConfig(UartID, UART_INTCFG_RBR, ENABLE);
}
break;
}
}




void UARTX_ENABLE(UART_ID_Type UartID,uint32_t Baud_rate,UART_PARITY_Type Parity,UART_DATABIT_Type Databits,UART_STOPBIT_Type Stopbits,uint32_t TRANSMIT_INTERRUPT,uint32_t RECEVE_INTERRUPT,uint8_t set_priority )
{
	UART_CFG_Type UARTConfigStruct;
		// UART FIFO configuration Struct variable
	UART_FIFO_CFG_Type UARTFIFOConfigStruct;
	switch(UartID)
	{
		case UART_0:
		{
	PINSEL_ConfigPin(0,2,1);
	PINSEL_ConfigPin(0,3,1);
		}
break;
				case UART_1:
		{
	PINSEL_ConfigPin(3,16,3);
	PINSEL_ConfigPin(3,17,3);
		}
break;
				case UART_2:
		{
	PINSEL_ConfigPin(4,22,2);
	PINSEL_ConfigPin(4,23,2);
		}
break;
				case UART_3:
		{
	PINSEL_ConfigPin(4,29,2);
	PINSEL_ConfigPin(4,28,2);
		}
break;
				case UART_4:
		{
	PINSEL_ConfigPin(5,3,4);
	PINSEL_ConfigPin(5,4,4);
		}
break;
	}		
	UARTConfigStruct.Baud_rate=Baud_rate;
	UARTConfigStruct.Databits=Databits;
	UARTConfigStruct.Parity=Parity;
	UARTConfigStruct.Stopbits=Stopbits;
	UART_Init(UartID, &UARTConfigStruct);
		UART_FIFOConfigStructInit(&UARTFIFOConfigStruct);

	// Initialize FIFO for UART0 peripheral
	UART_FIFOConfig(UartID, &UARTFIFOConfigStruct);
		// Enable UART Transmit
	UART_TxCmd(UartID, ENABLE);

    /* Enable UART Rx interrupt */
//	if(RECEVE_INTERRUPT==ENABLE)
	UART_IntConfig(UartID, UART_INTCFG_RBR, ENABLE);
	    /* Enable UART Rx interrupt */
//	if(TRANSMIT_INTERRUPT==ENABLE)
	UART_IntConfig(UartID,UART_INTCFG_THRE, ENABLE);
	/* Enable UART line status interrupt */
	UART_IntConfig(UartID, UART_INTCFG_RLS, ENABLE);
	
		switch(UartID)
	{
		case UART_0:
		{
    TxIntStat0 = RESET;
		// Reset ring buf head and tail idx
		BUF0_RESET(rb0.rx_head);
		BUF0_RESET(rb0.rx_tail);
		BUF0_RESET(rb0.tx_head);
		BUF0_RESET(rb0.tx_tail);
				/* preemption = 1, sub-priority = 1 */
			NVIC_SetPriority(UART0_INTERRUPT,set_priority);
				/* Enable Interrupt for UART0 channel */
			NVIC_EnableIRQ(UART0_INTERRUPT);			
		}
break;
				case UART_1:
		{
    TxIntStat1 = RESET;
		// Reset ring buf head and tail idx
		BUF1_RESET(rb1.rx_head);
		BUF1_RESET(rb1.rx_tail);
		BUF1_RESET(rb1.tx_head);
		BUF1_RESET(rb1.tx_tail);
				/* preemption = 1, sub-priority = 1 */
			NVIC_SetPriority(UART1_INTERRUPT,set_priority);
				/* Enable Interrupt for UART0 channel */
			NVIC_EnableIRQ(UART1_INTERRUPT);					

		}
break;
				case UART_2:
		{
    TxIntStat2 = RESET;
		// Reset ring buf head and tail idx
		BUF2_RESET(rb2.rx_head);
		BUF2_RESET(rb2.rx_tail);
		BUF2_RESET(rb2.tx_head);
		BUF2_RESET(rb2.tx_tail);
				/* preemption = 1, sub-priority = 1 */
			NVIC_SetPriority(UART2_INTERRUPT,set_priority);
				/* Enable Interrupt for UART0 channel */
			NVIC_EnableIRQ(UART2_INTERRUPT);					

		}
break;
				case UART_3:
		{
    TxIntStat3 = RESET;
		// Reset ring buf head and tail idx
		BUF3_RESET(rb3.rx_head);
		BUF3_RESET(rb3.rx_tail);
		BUF3_RESET(rb3.tx_head);
		BUF3_RESET(rb3.tx_tail);
				/* preemption = 1, sub-priority = 1 */
			NVIC_SetPriority(UART3_INTERRUPT,set_priority);
				/* Enable Interrupt for UART0 channel */
			NVIC_EnableIRQ(UART3_INTERRUPT);					

		}
break;
				case UART_4:
		{
    TxIntStat4 = RESET;
		// Reset ring buf head and tail idx
		BUF4_RESET(rb4.rx_head);
		BUF4_RESET(rb4.rx_tail);
		BUF4_RESET(rb4.tx_head);
		BUF4_RESET(rb4.tx_tail);
				/* preemption = 1, sub-priority = 1 */
			NVIC_SetPriority(UART4_INTERRUPT,set_priority);
				/* Enable Interrupt for UART0 channel */
			NVIC_EnableIRQ(UART4_INTERRUPT);		
		}
break;
	}	
	
	
	
		


		
	
}


void UARTX_send_string(UART_ID_Type UartID,char *string,uint8_t mode)
{
	
	
		
static volatile uint32_t count0_1=0,count0_2=0,count1_1=0,count1_2=0,count2_1=0,count2_2=0,count3_1=0,count3_2=0,count4_1=0,count4_2=0;
static uint32_t flag0=0,flag1=0,flag2=0,flag3=0,flag4=0;	
	
	uint32_t len;
	len=len+1;

	switch(UartID)
	{
		case UART_0:
		{
if(mode==TIME_SHARING)
{
if(*(string+count0_1)&&flag0==0)
{
count0_1++;	
}
else
if(*(string+count0_1)==0)	{
		flag0=1;
	
}
if(flag0==1&&count0_2<=count0_1)
{
	len=UARTX_Send(UART_0,(uint8_t *)string,count0_1,count0_2,TIME_SHARING);
	count0_2++;
if(count0_2==count0_1)
{
	flag0=0;
	count0_2=0;
	count0_1=0;
}
}
}
else
{	
while(*(string+count0_1))
{
len=UARTX_Send(UART_0,(uint8_t *)(string+count0_1),1,0,RING);
	count0_1++;

}

count0_1=0;
flag0=0;
count0_2=0;
}
		}
break;
				case UART_1:
		{
if(mode==TIME_SHARING)
{
if(*(string+count1_1)&&flag1==0)
{
count1_1++;	
}
else
if(*(string+count1_1)==0)	{
		flag1=1;
	
}
if(flag1==1&&count1_2<=count1_1)
{
	len=UARTX_Send(UART_1,(uint8_t *)string,count1_1,count1_2,TIME_SHARING);
	count1_2++;
if(count1_2==count1_1)
{
	flag1=0;
	count1_2=0;
	count1_1=0;
}
}
}
else
{	
while(*(string+count1_1))
{
len=UARTX_Send(UART_1,(uint8_t *)(string+count1_1),1,0,RING);
	count1_1++;

}

count1_1=0;
flag1=0;
count1_2=0;
}
		}
break;
				case UART_2:
		{
if(mode==TIME_SHARING)
{
if(*(string+count2_1)&&flag2==0)
{
count2_1++;	
}
else
if(*(string+count2_1)==0)	{
		flag2=1;
	
}
if(flag2==1&&count2_2<=count2_1)
{
	len=UARTX_Send(UART_2,(uint8_t *)string,count2_1,count2_2,TIME_SHARING);
	count2_2++;
if(count2_2==count2_1)
{
	flag2=0;
	count2_2=0;
	count2_1=0;
}
}
}
else
{	
while(*(string+count2_1))
{
len=UARTX_Send(UART_2,(uint8_t *)(string+count2_1),1,0,RING);
	count2_1++;

}

count2_1=0;
flag2=0;
count2_2=0;
}
		}
break;
				case UART_3:
		{
if(mode==TIME_SHARING)
{
if(*(string+count3_1)&&flag3==0)
{
count3_1++;	
}
else
if(*(string+count3_1)==0)	{
		flag3=1;
	
}
if(flag3==1&&count3_2<=count3_1)
{
	len=UARTX_Send(UART_3,(uint8_t *)string,count3_1,count3_2,TIME_SHARING);
	count3_2++;
if(count3_2==count3_1)
{
	flag3=0;
	count3_2=0;
	count3_1=0;
}
}
}
else
{	
while(*(string+count3_1))
{
len=UARTX_Send(UART_3,(uint8_t *)(string+count3_1),1,0,RING);
	count3_1++;

}

count3_1=0;
flag3=0;
count3_2=0;
}
		}
break;
				case UART_4:
		{
if(mode==TIME_SHARING)
{
if(*(string+count4_1)&&flag4==0)
{
count4_1++;	
}
else
if(*(string+count4_1)==0)	{
		flag4=1;
	
}
if(flag4==1&&count4_2<=count4_1)
{
	len=UARTX_Send(UART_4,(uint8_t *)string,count4_1,count4_2,TIME_SHARING);
	count4_2++;
if(count4_2==count4_1)
{
	flag4=0;
	count4_2=0;
	count4_1=0;
}
}
}
else
{	
while(*(string+count4_1))
{
len=UARTX_Send(UART_4,(uint8_t *)(string+count4_1),1,0,RING);
	count4_1++;

}

count4_1=0;
flag4=0;
count4_2=0;
}
		}
break;
	}	
	


}
void UARTX_receive_string(UART_ID_Type UartID,uint8_t *string,uint8_t mode)
{
static volatile uint32_t count0_1=0,count0_2=0,count1_1=0,count1_2=0,count2_1=0,count2_2=0,count3_1=0,count3_2=0,count4_1=0,count4_2=0;
//static uint32_t flag0=0,flag1=0,flag2=0,flag3=0,flag4=0;	
	uint8_t temp0='\0',temp1='\0',temp2='\0',temp3='\0',temp4='\0';
	//uint32_t len=0;
switch(UartID)

{
case UART_0:
{
	UARTX_Receive(UART_0,&temp0,1,mode);	
if(temp0!='^')
{
	if(mode==TIME_SHARING)
{
if(temp0!='\0')
{
*(string+count0_1)=temp0;
count0_1++;
	temp0=0;
	}
else
	{
temp0=0;
}

}
else
{
while(temp0!='^')
{	
if(temp0!='\0')
{
*(string+count0_1)=temp0;	
count0_1++;
	temp0=0;	
}
UARTX_Receive(UART_0,&temp0,1,mode);	
}
temp0=0;
count0_1=0;
}	
}
else
{
		count0_1=0;
	temp0=0;	
	}
}

break;
case UART_1:
{
	UARTX_Receive(UART_1,&temp1,1,mode);	
if(temp1!='^')
{
	if(mode==TIME_SHARING)
{
if(temp1!='\0')
{
*(string+count1_1)=temp1;
count1_1++;
	temp1=0;
	}
else
	{
temp1=0;
}

}
else
{
while(temp1!='^')
{	
if(temp1!='\0')
{
*(string+count1_1)=temp1;	
count1_1++;
	temp1=0;	
}
UARTX_Receive(UART_1,&temp1,1,mode);	
}
temp1=0;
count1_1=0;
}	
}
else
{
		count1_1=0;
	temp1=0;	
	}
}

break;
case UART_2:
{
	UARTX_Receive(UART_2,&temp2,1,mode);	
if(temp2!='^')
{
	if(mode==TIME_SHARING)
{
if(temp2!='\0')
{
*(string+count2_1)=temp2;
count2_1++;
	temp2=0;
	}
else
	{
temp2=0;
}

}
else
{
while(temp2!='^')
{	
if(temp2!='\0')
{
*(string+count2_1)=temp2;	
count2_1++;
	temp2=0;	
}
UARTX_Receive(UART_2,&temp2,1,mode);	
}
temp2=0;
count2_1=0;
}	
}
else
{
		count2_1=0;
	temp2=0;	
	}
}

break;
case UART_3:
{
	UARTX_Receive(UART_3,&temp3,1,mode);	
if(temp3!='^')
{
	if(mode==TIME_SHARING)
{
if(temp3!='\0')
{
*(string+count3_1)=temp3;
count3_1++;
	temp3=0;
}
else
	{
temp3=0;
}

}
else
{
while(temp3!='^')
{	
if(temp3!='\0')
{
*(string+count3_1)=temp3;	
count3_1++;
	temp3=0;	
}
UARTX_Receive(UART_3,&temp3,1,mode);	
}
temp3=0;
count3_1=0;
}	
}
else
{
		count3_1=0;
	temp3=0;	
	}
}

break;
case UART_4:
{
	UARTX_Receive(UART_4,&temp4,1,mode);	
if(temp4!='^')
{
	if(mode==TIME_SHARING)
{
if(temp4!='\0')
{
*(string+count4_1)=temp4;
count4_1++;
	temp4=0;
	}
else
	{
temp4=0;
}

}
else
{
while(temp4!='^')
{	
if(temp4!='\0')
{
*(string+count4_1)=temp4;	
count4_1++;
	temp4=0;	
}
UARTX_Receive(UART_4,&temp4,1,mode);	
}
temp4=0;
count4_1=0;
}	
}
else
{
		count4_1=0;
	temp4=0;	
	}
}

break;
}
}
